module FFmpegProgress
  # Helper methods.
  module Utils
    # The bell file to be used to signal completion.
    BELL = "#{File.expand_path('../../..', __FILE__)}/" \
      'assets/LucasGonze_StLouisWaltz.ogg'

    # Play the bell sound.
    #
    # @return [Integer] the PID of the bell process.
    def bell
      ffplay =
        spawn "ffplay -nodisp -autoexit '#{BELL}' &> /dev/null"
      Process.detach(ffplay)
      ffplay
    end

    # Parse a time string in the +ffmpeg+ +HH:MM:SS.ms+ format and
    # return seconds.
    #
    # @param [String] time_string
    # @return [Integer]
    def parse_ffmpeg_time(time_string)
      array = time_string.rpartition('.').first.split(':').map(&:to_i)

      array[0] * 3600 + array[1] * 60 + array[2]
    end
  end
end
